/*
 * SuperOfferSupplierHandler.java
 *
 * Created on 17 de agosto de 2004, 13:31
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.Log;
import com.fenalco.entities.SuperOffer;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.database.Transaction;

import java.sql.Date;

/**
 * Este servlet se encarga de realizar las operaciones necsarias para actualizar
 * los datos de una superoferta en la base de datos.
 * 
 * @author andres
 */
public class SuperOfferSupplierHandler extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Crea un objeto del tipo <CODE>SupperOffer</CODE> con los datos del
	 * formulario de actualización de la superoferta y luego hace un llamado al
	 * método <CODE>saveData</CODE>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
                                
                            url = "/proveedor/superofertasproveedor";
                            String operationType = request.getParameter( "operationType" );
                            if( operationType != null && !operationType.equals( "" ) ){
                                
                                //System.out.println( "OT: " + operationType );
                                
                                SuperOffer superOffer;
                                Transaction t;
                                User supplier = ( User )request.getSession().getAttribute( "user" );
                                
                                if( operationType.equals( "new" ) ){
                                
                                    //CREAR SUPEROFERTA
                                    superOffer = new SuperOffer();
                                    t = new Transaction();
                                    boolean failure = false;
                                    
                                    superOffer.setSupplierId( supplier.getCompanyId() );
                                    superOffer.setStartDate( Date.valueOf( request.getParameter( "startDate" ) ) );
                                    superOffer.setEndDate( Date.valueOf( request.getParameter( "endDate" ) ) );
                                    superOffer.setDescription( request.getParameter( "description" ) );
                                    java.util.Date now = new java.util.Date();
                                    
                                    System.out.println( superOffer.getStartDate() + " " +superOffer.getEndDate() );
                                    System.out.println( now );
				    
                                    if( (
                                        superOffer.getStartDate().getYear() < now.getYear() && 
                                        superOffer.getStartDate().getMonth() < now.getMonth() &&
                                        superOffer.getStartDate().getDate() < now.getDate() 
                                        ) ){
                                            
                                        message = "Las fechas utilizadas no pueden ser anteriores a la fecha actual.";
                                        failure = true;
                                        
                                    }
					
                                    
                                    if( superOffer.getEndDate().getTime() < superOffer.getStartDate().getTime() ){
                                        message = "La fecha de terminación debe ser mayor a la de inicio";
                                        failure = true;
                                    }
                                    
                                    superOffer.saveData( t );
                                    
                                    if( failure || !t.execute() ){
                                    
                                        //Fallo al crear superOferta
                                        //message = MessageBuilder.buildMessage( 7 );
                                        
                                    }else{
                                    
                                        //Creación exitosa
                                        message = MessageBuilder.buildMessage( 4 );
                                        url = "/proveedor/actualizarsuperofertaproveedor?key="+superOffer.getId()+"&operationType=update";
                                        try
                                        {
                                            Transaction t1 = new Transaction( );
                                            Log l = new Log( );
                                            User user = ( User )session.getAttribute( "user" );
                                            String userId = user.getLogin();
                                            String numberId = user.getIdentificationNumber();
                                            String externalUser = "";
                                            String description = "Creación de Super Oferta " + superOffer.getDescription() + " para el proveedor "+supplier.getCompanyName();
                                            User callcenter = ( User )session.getAttribute( "callcenter" );
                                            
                                            if( callcenter != null )
                                            {
                                                externalUser = callcenter.getLogin();
                                            }
                                            
                                            l.saveData(userId, numberId, 59, description, externalUser, t1 );
                                            t1.execute();
                                            
                                        }
                                        catch( Exception ex )
                                        {
                                            System.out.println( "Error guardando el Log." );
                                        }
                                        
                                    }
                                    
                                }else if( operationType.equals( "delete" ) ){
                                
                                    //ELIMINAR SUPEROFERTAS
                                    if( request.getParameterValues( "item" ) != null ){
                                    
                                        String[] items = request.getParameterValues( "item" );
                                        t = new Transaction();
                                        
                                        for( int i=0; i<items.length; i++ ){
                                            
                                            superOffer = new SuperOffer( Integer.parseInt( items[i] ) );
                                            superOffer.delete( t );
                                            
                                        }
                                        
                                        
                                        if( !t.execute() ){
                                        
                                            //Fallo al eliminar superOfertas
                                            message = MessageBuilder.buildMessage( 8 );
                                            
                                        }else{
                                        
                                            //Eliminación exitosa
                                            message = MessageBuilder.buildMessage( 5 );
                                            
                                            try
                                            {
                                                Transaction t1 = new Transaction( );
                                                Log l = new Log( );
                                                User user = ( User )session.getAttribute( "user" );
                                                String userId = user.getLogin();
                                                String numberId = user.getIdentificationNumber();
                                                String externalUser = "";
                                                String description = "Eliminación de Super Ofertas por el proveedor "+supplier.getCompanyName();
                                                User callcenter = ( User )session.getAttribute( "callcenter" );

                                                if( callcenter != null )
                                                {
                                                    externalUser = callcenter.getLogin();
                                                }

                                                l.saveData(userId, numberId, 60, description, externalUser, t1 );
                                                t1.execute();

                                            }
                                            catch( Exception ex )
                                            {
                                                System.out.println( "Error guardando el Log." );
                                            }
                                            
                                        }
                                        
                                    }//Fin Chequeo de arreglo de ids para eliminar
                                    
                                }else if( operationType.equals( "update" ) ){
                                
                                    //ACTUALIZAR SUPEROFERTA
                                    int superOfferId = Integer.parseInt( request.getParameter( "superOfferId") );
                                    boolean failure = false;
                                    superOffer = new SuperOffer( superOfferId );
                                    t = new Transaction();
                                    
                                    superOffer.setStartDate( Date.valueOf( request.getParameter( "startDate" ) ) );
                                    superOffer.setEndDate( Date.valueOf( request.getParameter( "endDate" ) ) );
                                    
                                    System.out.println( superOffer.getStartDate() + " " +superOffer.getEndDate() );
                                    java.util.Date now = new java.util.Date();
                                    System.out.println( now );
                                    
                                    
                                    if( 
                                        (
                                        superOffer.getStartDate().getYear() < now.getYear() && 
                                        superOffer.getStartDate().getMonth() < now.getMonth() &&
                                        superOffer.getStartDate().getDate() < now.getDate() 
                                        ) 
                                        ){
                                            
                                        message = "Las fechas utilizadas no pueden ser anteriores a la fecha actual.";
                                        failure = true;
                                        
                                    }
                                    
                                    if( superOffer.getEndDate().getTime() < superOffer.getStartDate().getTime() ){
                                        message = "La fecha de terminación debe ser mayor a la de inicio";
                                        failure = true;
                                    }
                                    
                                    superOffer.setDescription( request.getParameter( "description" ) );
                                    
                                    try{
                                        
                                        superOffer.setStock( Integer.parseInt( request.getParameter( "stock" ) ) );
                                        superOffer.update( t );
                                        
                                    }catch( NumberFormatException nfe ){
                                    
                                        message = "La cantidad ingresada no es válida";
                                        failure = true;
                                    }
                                    
                                    if( failure || !t.execute() ){
                                    
                                        //Fallo actualización
                                        //message = MessageBuilder.buildMessage( 7 );
                                        
                                    }else{
                                    
                                        //Actualización exitosa
                                        message = MessageBuilder.buildMessage( 4 );
                                        
                                        try
                                        {
                                            Transaction t1 = new Transaction( );
                                            Log l = new Log( );
                                            User user = ( User )session.getAttribute( "user" );
                                            String userId = user.getLogin();
                                            String numberId = user.getIdentificationNumber();
                                            String externalUser = "";
                                            String description = "Actualización de Super Ofertas "+superOffer.getDescription();
                                            User callcenter = ( User )session.getAttribute( "callcenter" );

                                            if( callcenter != null )
                                            {
                                                externalUser = callcenter.getLogin();
                                            }

                                            l.saveData(userId, numberId, 46, description, externalUser, t1 );
                                            t1.execute();

                                        }
                                        catch( Exception ex )
                                        {
                                            System.out.println( "Error guardando el Log." );
                                        }
                                    }
                                    
                                }
                                
                            }//operationType
                                
				
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
                e.printStackTrace();
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una descripción general del servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}